#!/usr/bin/php
<?php

// This script will output --virtuals and estimated-- W in/out and self-consumption counters into a meterN compatible format
// It is simply based on your household's production and consumption real meters.
// This script read PRODUCTION and CONSUMPTION from METERN (not 123Solar)
// The self-consumption estimation is only valid if the consumption and production is on the same phase.
// ln -s /var/www/comapps/eflowlivemn.php /usr/local/bin/eflowlivemn
// eflowlivemn [ whout | whin | selfc ]
// Modificato:.....Flavio Anesi
// Date:...........27/08/2018
// Vers:...........1.1

$MNDIR    = '/var/www/metern'; // Path to meterN

// Setup your meters identification numbers :
$PRODMET  = 1; // Meter ID Produzione
$CONSMET  = 2; // Meter ID Consumi
$whinmet  = 3; // Meter ID Prelievi (Whin)
$whoutmet = 4; // Meter ID Immissioni (Whout) 
$selfcmet = 5; // Meter ID Autoconsumo (selfc)

// No edit is needed below

if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}

define('checkaccess', TRUE);
include("$MNDIR/config/config_main.php");
include("$MNDIR/config/config_met$CONSMET.php");
include("$MNDIR/config/config_met$PRODMET.php");
include("$MNDIR/config/memory.php");
date_default_timezone_set($DTZ);

if (!isset($argv[1])) {
	$argv[1]=null;
}

if ($argv[1]== 'whout' || $argv[1]=='whin' || $argv[1]=='selfc') {
 	
	if (file_exists($LIVEMEMORY)) {
    $data   = file_get_contents($LIVEMEMORY);
    $array  = json_decode($data, true);
    $nowutc = strtotime(date('Ymd H:i:s'));

	settype($nowUTC, 'float');
	
	if ($nowUTC - $array["UTC"] < 15 && isset($array['UTC'])) {
		$housep = $array["${'METNAME'.$PRODMET}$PRODMET"]; // Produzione 
		$housec = $array["${'METNAME'.$CONSMET}$CONSMET"]; // Consumo 
	} else { // Too old
		$housep = 0;
		$housec = 0;
	}
	#echo "Produzione: $housep\n";
	#echo "Consumo: $housec\n";
           
    if ($argv[1] == 'whout') { // immissioni
		$val = $housep - $housec;
		$val = round($val,0);
		if ($val < 0) {
			$val = 0;
		}
		$id = $whoutmet;
	}
				
	if ($argv[1] == 'whin') { // prelievi
		$val = $housec - $housep;
		$val = round($val,0);
		if ($val < 0) {
			$val = 0;
		}
		$id = $whinmet;
	}
					
	if ($argv[1] == 'selfc') { // autoconsumo
		if ($housep > $housec) {
			$val = $housec;
			$val = round($val,0);
		} else {
			$val = $housep;
			$val = round($val,0);
		}
		$id = $selfcmet;
	}

    $str = utf8_decode("$id($val*W)\n");
	echo "$str";
	}
} else {
	die("Usage: eflowlivemn { whout | whin | selfc }\n");
}
?>
